from sklearn import tree
import matplotlib.pyplot as plt
from sklearn.ensemble import RandomForestClassifier
from math import *
from sklearn.cluster import KMeans
import numpy as np

f = open("conso_new.txt", "r")
Time = []
Conso_tot = []
four = []
lave_vaisselle = []
plaques_cuissons = []
temp = []
machine_laver = []
Title = f.readline()
for line in f:
    line_token=line.split("		")
    Time.append(float(line_token[0][0] + line_token[0][1]))
    Conso_tot.append(float(line_token[1]))
    four.append(float(line_token[2]))
    lave_vaisselle.append(float(line_token[3]))
    plaques_cuissons.append(float(line_token[4]))
    temp.append(float(line_token[5]))
    machine_laver.append(float(line_token[6]))
f.close()
print(Time)
#print(len(Conso_tot))
#print(len(four))
#print(len(lave_vaisselle))
#print(len(plaques_cuissons))
#print(len(temp))
#print(len(machine_laver))
def arrondi(x):
    if abs(x//1 - x) < 0.5:
        x = x//1
    else:
        x = x//1 +1
    return x

N=50
n=len(four)-N
temp_arrondi=[]
for i in range (len(temp)):
    temp_arrondi.append(arrondi(temp[i]))




temp_300, temp_66 = [], []
Feature = []
Predi = []
for i in range (n):
    f = [Time[i], four[i], lave_vaisselle[i], plaques_cuissons[i], machine_laver[i]]
    Feature.append(f)
    temp_300.append(temp_arrondi[i])

for i in range (N):
    f = [Time[i+n], four[i+n], lave_vaisselle[i+n], plaques_cuissons[i+n], machine_laver[i+n]]
    Predi.append(f)
    temp_66.append(temp_arrondi[i+n])

classification=tree.DecisionTreeClassifier(random_state = 0, criterion = 'entropy', max_depth = 4)
classification.fit(Feature, temp_300)
a=classification.predict(Predi)

with open("treeprojet.dot", 'w') as file:
    f = tree.export_graphviz(classification , out_file=file)

depth=[]
for i in range (1,12):
    classification = tree.DecisionTreeClassifier(random_state=0, criterion='entropy', max_depth=i)
    classification.fit(Feature, temp_300)
    depth.append(classification.predict(Predi))
#print(depth)
x=np.linspace(1,11,11)



ERROR = []
ACCURACY = []
s=0
accuracy=0
for i in range(11):
    for j in range (N):
        s += abs((depth[i][j] - temp_66[j]))
        if depth[i][j] == temp_66[j]:
            accuracy += 1
    ERROR.append(s)
    ACCURACY.append(accuracy)
    s=0
    accuracy=0

S4=[]
S5=[]
for i in range (len(ERROR)):
    S4.append(ERROR[i]/N)
    S5.append(ACCURACY[i] / N)


plt.plot(temp_66, label = "real temperature", color = 'r')
plt.plot(a,label = "temperature prediction", color = 'y')
#plt.plot(x,S4,label = "error with the depth")
#plt.plot(x,S5,label = "accuracy with the depth")
plt.legend()
plt.show()